#include <cmath>
#include <string>
#include <random>
#include <vector>
#include <Eigen/Dense>

#include <Rcpp.h>
#include <RcppEigen.h>
// [[Rcpp::plugins(cpp14)]]
// [[Rcpp::depends(RcppEigen)]]

using namespace Rcpp;

//Usefull data structures

typedef std::function<double(double)> func;
typedef Eigen::MatrixXd MyMat;
typedef Eigen::VectorXd MyVec;

//typedef arma::mat MyMat;
//typedef arma::vec MyVec;

///////////////////////////////////////////////////
/////            Usefull functions             ////
///////////////////////////////////////////////////

//Definition of an indicator function
double indicatrice(double a, double b, double x)
       {
 if(a<=x && x<b){
  return 1.;}
 else
  return 0.; 
       }
// [[Rcpp::export]]
auto partition(int const n)
     {std::random_device rd;  //Will be used to obtain a seed for the random number engine
      std::mt19937 gen(rd()); //Standard mersenne_twister_engine seeded with rd()
      std::uniform_real_distribution<> dis(0,1);
      double x=dis(gen);
      double length=x;
      MyVec DistRes=MyVec::Zero(n);
      //std::vector<double> DistRes={};
      //DistRes.push_back(x);  // Initialisation de la liste
      DistRes(0)=x; // Intitialisation of the vector
    // Creation of n random length
    for (int i = 0; i < n-1; i++) 
      {
        // Use dis to transform the random unsigned int generated by gen into a 
        // double in [0, 1). Each call to dis(gen) generates a new random double
        x=dis(gen);
        length+=x;
        DistRes(i+1)=x;
       }
     DistRes=DistRes/length;
     return DistRes;
     }

// Function to spatialise the growth rate of the pathogen
// [[Rcpp::export]]
auto Terrain_hetero(double const& R, double const& deltaspace, MyVec const& txcroissance_par_env, MyVec const& size_env)  
     {
      // Useful integer for construction
      int dimx =1+2*R/deltaspace; // size of the discretization
      int nbre_env=size_env.size(); // Total number of environments
      int taille_liste_txcroiss =txcroissance_par_env.size();
      MyVec Hetero=Eigen::VectorXd::Zero(dimx);
      if(nbre_env==taille_liste_txcroiss)
        {
        // Creation of the partition of [-R,R] with the size_env
        MyVec Partition=Eigen::VectorXd::Zero(nbre_env+1);
        Partition(0)=-R;
        //std::cout<< Partition(0)<<"\n\n"<<std::endl;
        for(int i=0; i<nbre_env; i++)
          {
          Partition(i+1)=Partition[i]+2*R*size_env[i];
          }

        Hetero(dimx-1)=txcroissance_par_env[nbre_env-1];
        for (int i=0;i<dimx;i++)
           { 
            for (int j=0;j<nbre_env;j++)
               {
                Hetero(i) += txcroissance_par_env[j]*indicatrice(Partition(j),Partition(j+1),-R+i*deltaspace);
               }
           }
        return Hetero;
         }
        else 
        return Hetero;
     }


///////////////////////////////////////////////////
/////  Definition of dispersal functions       ////
///////////////////////////////////////////////////

//Dispersal function for the mean dispersal distance lambda=Alpha

//Exponantial dispersal kernel
double NoyauExp(double const& x,double const& lambda)
      {
       double Alpha = lambda;
       return (1/(2*Alpha))*exp(-fabs(x)/Alpha) ;
      }


// Gauss dispersal kernel
//The mean dispersal distance is lambda=Alpha/racine(pi)
double NoyauGauss(double const& x,double  const& lambda)
 {
 double Alpha = lambda*sqrt(M_PI);
return (1/(sqrt(M_PI)*Alpha))*exp(-pow(x/Alpha,2)) ;
 }

//Exponantial-Power dispersal kernel
//The mean dispersal distance is lambda=Alpha*Gamma(2/taup)/Gamma(1/taup)

double NoyauExpPuiss(double  const& x,double  const& lambda, double const& taup)
{
double Alpha = lambda*tgamma(1/taup)/tgamma(2/taup) ;
return (taup/(2*Alpha*tgamma(1/taup)))*exp(-pow(fabs(x)/Alpha,taup)) ;
}

// Dispersal kernel function
double  NoyauDisp(double const& x, std::string const& noyau, double const& lambda, double const& taup)
{
if (noyau=="Exp") 
{return NoyauExp(x,lambda);}
else if (noyau=="Gauss"){return NoyauGauss(x,lambda);}
else 
return NoyauExpPuiss(x,lambda,taup);
}

// Function for the matrix creation for I.D. Model
auto FillMatrix_ID( double const& R, double  const& delta, std::string  const& noyau, double const& lambda, double const& taup)
{  // Dimension of discretization
   int dimx = 1+2*R/delta ;
   
   // Definition of matrices and vectors for construction
   MyMat A = MyMat::Zero(dimx,dimx) ;
   MyMat B = MyMat::Zero(dimx,dimx) ;
   MyMat D = MyMat::Zero(dimx,dimx) ;
   MyVec Vec = MyVec::Zero(dimx) ;
   MyVec Ones = Eigen::VectorXd::Ones(dimx) ;
   //MyVec Ones = arma::ones<MyVec>(dimx);
         
   // Start of the construction of the arrival matrix A 
   for (int i = 0 ; i < dimx; i++)
     { 
      for (int j = i ; j < dimx; j++)
         {
          A(i,j) = delta*NoyauDisp((i-j)*delta,noyau, lambda, taup);
          if (i != j){ A(j,i) = A(i,j) ; }
         }
   
     }
     // End of the construction of the matrix A
     
     // Start of the construction of the starting matrix B 
     Vec = A*Ones ;
     B = Vec.asDiagonal() ;
     //B = arma::diagmat(Vec) ; 
     // End of the construction of the matrix B

     // Definition of the dispersal matrix D
     D = A-B ;
     // Definition of the matrix vector {A,D} as the output of the function
     std::vector<MyMat> Diff = {A,D} ;
     return Diff ;
}

// Function for the matrix creation for R.D. Model
auto FillMatrix_RD( double const& R, double  const& delta, double const& sigma)
{  // Dimension of discretization
   int dimx = 1+2*R/delta ;
   double d = sigma/(delta*delta); 
   
   // Definition of matrices and vectors for construction
   MyMat A = MyMat::Zero(dimx,dimx) ;
   MyMat D = MyMat::Zero(dimx,dimx) ;
   MyMat B = MyMat::Zero(dimx,dimx) ;
   MyVec Vec = Eigen::VectorXd::Ones(dimx) ; 
   //MyVec Vec = arma::ones<MyVec>(dimx);

   // Start of the construction of the arrival matrix A 
   for (int i=1;i<dimx-1;i++)
     {A(i,i+1) = 0.5;
      A(i,i-1) = 0.5;
     }
   A(0,1) = 0.5;
   A(dimx-1,dimx-2) = 0.5;
     // End of the construction of the matrix A
 
     // Start of the construction of the starting matrix B
      B = Vec.asDiagonal() ;
     //B = arma::diagmat(Vec) ;
     B(0,0) = 0.5;
     B(dimx-1,dimx-1) = 0.5; 
      //B = (sigma/delta)*B; 
      //B(0,0) = sigma/(2*delta) ;
      //B(dimx-1,dimx-1) = sigma/(2*delta) ;
     // End of the construction of the matrix B

     // Definition of the dispersal matrix D
     D = d*(A-B) ;
     // Definition of the matrix vector {A,D} as the output of the function
     std::vector<MyMat> Diff = {A,D} ;
     return Diff ;
}

//function to build the necessary matrices for the RD or ID models
auto FillMatrix( std::string const& model, double const& R, double  const& delta, std::string  const& noyau, double const& lambda, double const& taup, double const& sigma)
{  
if (model == "RD") 
{return FillMatrix_RD(R,delta,sigma) ;}
else 
return FillMatrix_ID(R,delta,noyau,lambda,taup) ;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////
//       Function to resolve  u_t= \int J(x-y)(u(y)-u(x))dy + u(r(x)-u) with Euler method               ///
////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Function to resolve the numerical scheme (Appendix A), from all constant and parameters
// [[Rcpp::export]]
auto Resolution_Euler_hetero(std::string const& model, int const& nbrjour, double const& R, double const& deltaspace, double const& deltatime, double const& K, std::string const& noyau, double const& lambda, double const& taup, double const& sigma, MyVec const& txcroissance_par_env, MyVec const& size_par_env,  MyVec const& VectInit)
{
//Definition of the dispersal matrix
  std::vector<MyMat> Diff = FillMatrix(model,R,deltaspace,noyau,lambda,taup,sigma) ;
  MyMat A = Diff[0] ; 
  MyMat D = Diff[1] ;  // dispersal matrix
  //std::cout<<"Mat de disp ="<< "\n"<<D<<"\n"<<std::endl;
  D=deltatime*D;
  // Definition of significant integers
  int nbrtemps = nbrjour/deltatime ; 
  int n = 1+(2*R)/deltaspace;                                                   
  //int n = A.rows() ;                 
  double ratio=deltatime/K ;
  int Nbre_env=size_par_env.size();

  //Definition of heterogeneous environment 
  MyVec RHetero=Terrain_hetero(R,deltaspace,txcroissance_par_env,size_par_env); 

  // Definition of vectors to define the population          
  //Eigen::VectorXd U_0,U, Uold ;      
  MyVec U_0,U, Uold;
  
  // Definition of the initial condition
  //U_0 = Eigen::VectorXd::Zero(n) ;
  U_0 = K*VectInit ;
  // U_0 = arma:zeros<MyVec>(n);                                                  
  //U = U_0 ;
  U = Eigen::VectorXd::Zero(n) ;
  //U_0(n-1) = K ;
  //U_0(n-2) = K ;
  //U_0(n-3) = K ;
  //U_0=A*U_0;

  // Definition of the vector list that will store the evolution of the population
  //std::vector<Eigen::VectorXd> MatRes(nbrtemps+1) ;
  std::vector<MyVec> MatRes(nbrtemps+1) ;
  // Initialization of the list with the initial condition
  MatRes.push_back(U_0) ;
  
  // Initialization of the Euler explicit scheme
  Uold = U_0 ;
 
 // Euler explicit scheme
  for (int k = 0; k < nbrtemps; k++)
    {MyVec U_2 = ratio*(Uold.array().pow(2)) ;
     MyVec U_hetero = deltatime*(RHetero.array()*Uold.array());
     // MyVec U_2 = ratio*pow(Uold,2);
    U=Uold+D*Uold + U_hetero-U_2 ;   
    MatRes.push_back(U) ; // Saving the result in the list 
    Uold=U ; // update of the variable Uold
    }
  // End of Euler explicit scheme
return MatRes ;
}